#!/usr/bin/env python

import roslib; roslib.load_manifest('harkviz')
import rospy
import threading
import time
import math
from hark_msgs.msg import HarkSource
from hark_msgs.msg import HarkSourceVal

from pylab import *
ion()

node_name = 'HarkSource_SourcePlotter'
topic_name = 'HarkSource'
disp_col_num = 500
disp_interval = 0.5
cb_count = 0
plot_data_x = []
plot_data_y = []
plot_data_id = []
cur_count = 0

# Command line arguments

for cnt in  range(len(sys.argv)) :
    if sys.argv[cnt] == '-h' or sys.argv[cnt] == '--help' :
        print '----------------------------------'
        print ''
        print 'USAGE : '
        print 'rosrun harkviz HarkSource_SourcePlotter.py -c INT -i FLOAT[sec] -t TopicName -n NodeName'
        print ''
        print '----------------------------------'
        sys.exit()
    if sys.argv[cnt] == '-c' or sys.argv[cnt] == '--column' :
        try: 
            disp_col_num = int(sys.argv[cnt + 1])
        except ValueError :
            print 'Error : invalid -c INT'
            sys.exit()
    if sys.argv[cnt] == '-i' or sys.argv[cnt] == '--interval' :
        try: 
            disp_interval = float(sys.argv[cnt + 1])
        except ValueError :
            print 'Error : invalid -i FLOAT'
            sys.exit()
    if sys.argv[cnt] == '-t' or sys.argv[cnt] == '--topic' :
        if '-' == sys.argv[cnt + 1][0] :
            print 'Error : invalid topic name'
            sys.exit()
        topic_name = sys.argv[cnt + 1]
    if sys.argv[cnt] == '-n' or sys.argv[cnt] == '--node' :
        if '-' == sys.argv[cnt + 1][0] :
            print 'Error : invalid topic name'
            sys.exit()
        node_name = sys.argv[cnt + 1]

# Plotting

def callback(data):        

    global plot_data_x
    global plot_data_y
    global plot_data_id
    global disp_col_num
    global cb_count
    global cur_count

    for snum in range(len(data.src)):

        find_flag = 0
        find_row = 0
        # print data.src[snum].id
        for psnum in range(len(plot_data_id)):
            if plot_data_id[psnum] == data.src[snum].id :
                find_row = psnum
                find_flag = 1                

        if find_flag == 0 :
            plot_data_id.append(data.src[snum].id)
            plot_data_x.append([data.count])
            plot_data_y.append([180.0 / math.pi * math.atan2(data.src[snum].y, data.src[snum].x)])
        else :
            plot_data_x[find_row].append(data.count)
            plot_data_y[find_row].append(180.0 / math.pi * math.atan2(data.src[snum].y, data.src[snum].x))
    
    # data trimming
    for i in range(len(plot_data_x)) : 
        trim_x = 0
        for j in range(len(plot_data_x[i])) :
            if plot_data_x[i][j] < data.count - disp_col_num :
                trim_x = j
        plot_data_x[i] = plot_data_x[i][trim_x:]
        plot_data_y[i] = plot_data_y[i][trim_x:]
                        
    cb_count = cb_count + 1
    print cb_count
    cur_count = data.count

# Plotting

class plotthread(threading.Thread):

    global plot_data_x
    global plot_data_y
    global disp_interval
    global cur_count

    def __init__(self):
        threading.Thread.__init__(self)
        self.setDaemon(True)

    def run(self):
        print "Plotting Start."
        while True :
            for win in range(len(plot_data_x)):
                hold(True)
                if len(plot_data_x[win]) > 0 :
                    if win % 3 == 0 :
                        plot(plot_data_x[win], plot_data_y[win], 'r-')
                    if win % 3 == 1 :
                        plot(plot_data_x[win], plot_data_y[win], 'g-')
                    if win % 3 == 2 :
                        plot(plot_data_x[win], plot_data_y[win], 'b-')
                xlim((cur_count - disp_col_num, cur_count))
                ylim((-180, 180))
                hold(False)
            draw()    
            time.sleep(disp_interval)

# Main

def listener():
    global node_name
    global topic_name
    rospy.init_node(node_name, anonymous=True)
    rospy.Subscriber(topic_name, HarkSource, callback, None, 100)
    print "Plotter ready."
    rospy.spin()

if __name__ == '__main__':
    t = plotthread()
    t.start()
    listener()

